# Warning
For unknown reasons, these scripts require <= Python 3.9, otherwise the output is incomplete.

# Standard dumping steps

1. Dump the game with x64dbg's Scylla while it's running
2. Run REFramework's SDK dumper under `DeveloperTools`
3. Run the following commands (replace `re4` with your game name, and target the dumped executable)

```
python .\emulation-dumper.py --p="re4_dump.exe" --il2cpp_path="il2cpp_dump.json" --test_mode=False
python .\non-native-dumper.py --out_postfix="re4" --natives_path=".\native_layouts_re4_dump.exe.json" --il2cpp_path="il2cpp_dump.json" --use_typedefs=False --use_hashkeys=True
```

# `emulation-dumper.py`
Uses [Unicorn](https://github.com/unicorn-engine/unicorn) to emulate all of the deserializer chains to guess the RSZ structure layout for native (`via.*`) types.

### Arguments
* `p`
    * path to the game executable
* `il2cpp_path` 
    * path to `il2cpp_dump.json` (framework generated)
* `test_mode`
    * uses the `default_chains` global instead of `il2cpp_path` for chains

### Outputs
* `native_layouts_(exe_name).json`
* `dump_(exe_name).txt`

***

# `non-native-dumper.py`
* Generates the RSZ structures for non-native types
* Merges the natives into non-natives as needed (e.g. if a non-native has a native parent)
* Adds the native structures from `native_layouts_(exe_name).json` as well, so it's all in one file

### Arguments
* `out_postfix`
    * postfix added to output filename
* `il2cpp_path` 
    * path to `il2cpp_dump.json` (framework generated)
* `natives_path`
    * path to `native_layouts_(exe_name).json` that was generated by `emulation-dumper.py`
* `use_typedefs`
* `use_hashkeys`
* `include_parents`
    * Will add the parent object name to the struct or omitted if not found.

### Outputs
`rsz(out_postfix).json`
